Uses Crt, Dos, UScreen;
Type
  HeaderData = Record
    ID : Array[1..8] Of Char;
    UnKnow1 : Word;
    Folder : Array[1..8] Of Char;
    Comment : Array[1..40] Of Char;
    UnKnow2 : Word;
    UnKnow3 : LongInt;
    Name : Array[1..8] Of Char;
    UnKnow4 : LongInt;
    FileSize : LongInt;
    UnKnow5 : LongInt;
    DataSize : Array[1..4] of Byte;
  End;
  LevelHeader = Record
    ID : Array[1..2] Of Char;
    Ver : Word; {Version -> 1}
    NLevel : Word;
    CurrentLevel : Word;
  End;

Var
  F : File;
  G : Text;
  Head : HeaderData;
  LevelHead : LevelHeader;
  I, J : Word;
  Sign : String;
  CheckSum : Word;
  Data : Byte;
  Line : String;

  NLevel : Word;

  Screen : PScreen;


Procedure Error(ErrorStr : String);
Begin
  Move(Screen^, Mem[$B800:0000], BytesPerScreen);
  FreeMem(Screen, BytesPerScreen);
  Write(ErrorStr);
  Halt;
End;

Begin
  Car := Car2;

  WriteLn('Vexed Editor V1.0 by Gervaise Philippe aKa CandyMan');
  If ParamCount = 0 Then
  Begin
    WriteLn;
    WriteLn('VEdit <file>');
    Write('   <file> : Name of the file where levels are');
    Halt;
  End;

  Assign(G, ParamStr(1));
  {$I-}
  Reset(G);
  If IoResult <> 0 Then
  Begin
    Write('File ', ParamStr(1), ' doesn''t exist !');
    Halt;
  End;
  {$I+}

  Head.ID := '**TI89**';
  Head.UnKnow1 := 1;
  Head.Folder := 'main' + Chr(0) + '   ';
  For I := 1 To 40 Do
    Head.Comment[I] := Chr(0);
  Head.UnKnow2 := 1;
  Head.UnKnow3 := 82;
  Head.UnKnow4 := 12;
  Head.FileSize := 0; {Pour apres}
  Head.UnKnow5 := 23205;
  Head.DataSize[1] := 0;
  Head.DataSize[2] := 0;
  Head.DataSize[3] := 0;
  Head.DataSize[4] := 0;


  GetMem(Screen, BytesPerScreen);
  Move(Mem[$B800:0000], Screen^, BytesPerScreen);

  Line := Ask('Output filename (without extension): ', Alpha + Digit + NoSpace);
  Line := Line + '.89c';

  Assign(F, Line);
  {$I-}
  ReWrite(F, 1);
  If IoResult <> 0 Then Error('Output filename invalid !');
  {$I+}

  Line := Ask('Name that appeared in the calculator : ', All);
  If Length(Line) < 1 Then Error('Calculator filename invalid !');
  For I := 1 To 8 Do
  Begin
    Head.Name[I] := Line[I];
    If I + 1 > Length(Line) Then Break;
  End;
  If I < 8 Then Head.Name[I + 1] := Chr(0);

  BlockWrite(F, Head, SizeOf(HeaderData));

  LevelHead.ID := 'VX';
  LevelHead.Ver := 256; {Donne 1 en 68000}
  LevelHead.NLevel := 0;
  BlockWrite(F, LevelHead, SizeOf(LevelHeader));

  NLevel := 0;
  While Not(Eof(G)) Do
  Begin
    Data := 0; {Ecrit le mot 0 pour dire que le level n'est pas fait}
    BlockWrite(F, Data, 1);
    BlockWrite(F, Data, 1);
    For I := 1 To 8 Do
    Begin
      If Eof(G) Then Break;
      If I = 8 Then Inc(NLevel);
      ReadLn(G, Line);
      For J := 1 To 7 Do
      Begin
        Data := 0;

        If (Line[2 * J - 1] >= '1') And (Line[2 * J - 1] <= '8') Then
          Data := Ord(Line[2 * J - 1]) - 48;

        If Line[2 * J - 1] = '*' Then
          Data := 15;

        If (Line[2 * J] >= '1') And (Line[2 * J] <= '8') Then
          Data := Data + (Ord(Line[2 * J]) - 48) Shl 4;

        If Line[2 * J] = '*' Then
          Data := Data + 240; {15 * 16}

        BlockWrite(F, Data, 1);
      End;
    End;
    If Not(Eof(G)) Then ReadLn(G, Line);
  End;
  Close(G);

  LevelHead.NLevel := NLevel Shr 8 + (NLevel And 255) Shl 8;
  LevelHead.CurrentLevel := 0;
  Seek(F, SizeOf(HeaderData));
  BlockWrite(F, LevelHead, SizeOf(LevelHeader));

  Seek(F, FileSize(F));

  Data := 221; {ID Data, 45 -> String}
  BlockWrite(F, Data, 1);

  Seek(F, 0);
  Head.FileSize := FileSize(F);
  Head.DataSize[3] := (FileSize(F) - SizeOf(HeaderData)) Shr 8;
  Head.DataSize[4] := (FileSize(F) - SizeOf(HeaderData)) And 255;
  BlockWrite(F, Head, SizeOf(HeaderData));

  {Calcule le checksum}
  CheckSum := 0;
  Seek(F, 86);
  For I := 86 To FileSize(F) - 1 Do
  Begin
    BlockRead(F, Data, 1);
    Inc(CheckSum, Data);
  End;

  Seek(F, FileSize(F));
  Data := CheckSum And 255;
  BlockWrite(F, Data, 1);
  Data := CheckSum Shr 8;
  BlockWrite(F, Data, 1);

  Head.FileSize := FileSize(F);
  Seek(F, 0);
  BlockWrite(F, Head, SizeOf(HeaderData));

  Close(F);

  Move(Screen^, Mem[$B800:0000], BytesPerScreen);
  FreeMem(Screen, BytesPerScreen);
  Write('Well done !');
End.